#
# Copyright (c) 2025 Huawei Technologies Co., Ltd. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# This file is a part of the vllm-ascend project.
#

name: 'ascend test / nightly'

on:
  schedule:
      # Run test at 24:00 Beijing time (UTC+8)
      - cron: "0 16 * * *"
  workflow_dispatch:
  pull_request: 
    branches:
      - 'main'
      - '*-dev'
    paths:
      - 'tests/e2e/nightly/**'
      - '.github/workflows/vllm_ascend_test_nightly.yaml'

# Bash shells do not use ~/.profile or ~/.bashrc so these shells need to be explicitly
# declared as "shell: bash -el {0}" on steps that need to be properly activated.
# It's used to activate ascend-toolkit environment variables.
defaults:
  run:
    shell: bash -el {0}

# only cancel in-progress runs of the same workflow
# and ignore the lint / 1 card / 4 cards test type
concurrency:
  group: ascend-nightly-${{ github.ref }}
  cancel-in-progress: true

jobs:
  qwen3-32b:
    strategy:
      matrix:
        # should add A3 chip runner when available
        os: [linux-aarch64-a2-4]
    # Note (yikun): If CI resource are limited we can split job into two chain jobs
    # only trigger e2e test after lint passed and the change is e2e related with pull request.
    uses: ./.github/workflows/_e2e_nightly.yaml
    with:
      vllm: v0.11.0
      runner: ${{ matrix.os }}
      tests: tests/e2e/nightly/models/test_qwen3_32b.py
